/*
 * MIT License
 *
 * Copyright (c) 2019 norangebit
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

package it.norangeb.algorithms.sorting

import org.amshove.kluent.`should equal`
import org.junit.jupiter.api.Test

class QuicksortTest {

    @Test
    fun testSort() {
        val array = arrayOf(5, 2, 3, 1, 4)
        val arrayCopy = array.clone()

        Quicksort.sort(array)

        array `should equal` arrayCopy.sortedArray()
    }

    @Test
    fun testSortBy() {
        val array = arrayOf(5, 2, 1, 4, 3, 23, 12, 1, 89, 7)
        val arrayCopy = array.clone()

        Quicksort.sortBy(array) { it }

        array `should equal` arrayCopy.sortedArray()
    }

    @Test
    fun testSortWith() {
        val array = arrayOf(4, 5, 3, 2, 1)
        val arrayCopy = array.clone()

        Quicksort.sortWith(array) { t1, t2 ->
            t1.compareTo(t2)
        }

        array `should equal` arrayCopy.sortedArray()
    }
}